\documentclass[mathserif,aspectratio=169]{beamer}
\mode<presentation>{
    \usetheme{Warsaw}
    \setbeamercovered{transparent}
}
%\usepackage{pgf,pgfarrows,pgfnodes,pgfautomata,pgfheaps,pgfshade}
\usepackage{hyperref}
\usepackage{amsmath,amssymb,amsfonts}
\usepackage{graphicx}
\usepackage{manfnt}
%\usepackage{textcomp} %for per thousand symbol
%\usepackage{tikz}
\usepackage[utf8]{inputenc}
\usepackage[cache=false]{minted}

%\AtBeginSection[]
%{
%  \begin{frame}
%    \frametitle{Outlines}  %\insertsection to display section title
%    \tableofcontents[currentsection]
%  \end{frame}
%}

\definecolor{Magenta}{cmyk}{0,1,0,0}

\setbeamercovered{transparent}

\begin{document}

\title{Using ssh keys for secure communication with remote servers}

\author{Xijiang Yu}

\institute{BIOVIT NMBU, 1432 \AA s, Norway}

\date{May 15, 2024}

\titlegraphic{\includegraphics[height=.07\textwidth]{figure/logo.png}}

\frame{
    \titlepage
}

\frame{
    \frametitle{The minimal version}
    \begin{itemize}
        \item Generate a pair of SSH keys.
        \begin{itemize}
            \item the private one reside on your local computer
            \item the public one is to be managed by a server
        \end{itemize}
        \item Copy the public key to the remote server.
        \item Communicate local $\leftrightarrow$ remote
    \end{itemize}
}

\frame{
    \frametitle{A practical command line version}
    \begin{columns}
        \begin{column}{0.25\textwidth}
            \begin{itemize}
                \item<1> Generate SSH key pairs.
                \item<2> Copy the public key to the remote (GitLab).
                \item<3> Communicate local $\leftrightarrow$ remote
            \end{itemize}
        \end{column}
        \begin{column}{0.75\textwidth}
            \begin{itemize}
                \item<1> {\color{Magenta}{ssh-keygen -t ed25519 -C "desktop to gitlab"}}
                \begin{itemize}
                    \item $\Rightarrow$ {\color{cyan} id\_ed25519}, and {\color{cyan}id\_ed25519.pub} in {\color{cyan}$\sim$/.ssh}
                    \item better to add a \emph{strong} passphrase to {\color{cyan}id\_ed25519}.
                    \item Linux/Mac users may have to {\color{Magenta}chmod 700 $\sim$/.ssh}, and {\color{Magenta}chmod 600 id\_ed25519 config}.
                \end{itemize}
                \item<2> Place the pub key to remote
                \begin{itemize}
                    \item Copy the content in {\color{cyan}id\_rsa.pub} into memory.
                    \item \url{https://gitlab.com/-/user_settings/ssh_keys}
                    \item Button {\color{Magenta} Add new key}
                    \item paste into the {\color{cyan}Key} textbox.
                    \item configure {\color{cyan} $\sim$/.ssh/config} and manage private keys (Next slides)
                \end{itemize}
                \item<3> Communication
                \begin{itemize}
                    \item {\color{Magenta}git clone git@gitlab.com:your-user-name/repo-name}
                    \item {\color{Magenta}git push origin main}
                    \item {\color{Magenta}git pull origin main}
                \end{itemize}
            \end{itemize}
        \end{column}
    \end{columns}
}

\begin{frame}[fragile]
    \frametitle{Configure {\color{cyan}config}}
    \begin{itemize}
        \item On Linux: {\color{cyan}$\sim$/.ssh}, or Windows: {\color{cyan}C:/Users/xijiyu/.ssh}
        \item Append below into {\color{cyan}config}
    \end{itemize}

    \begin{minted}{unixconfig}
        Host gitlab
            User     git
            HostName gitlab.com
            PreferredAuthentications publickey
            IdentityFile C:\Users\xijiyu\.ssh\id_ed25519
    \end{minted}
\end{frame}

\begin{frame}[fragile]
    \frametitle{Manage your private keys}
    \begin{itemize}
        \item NMBU users
        \begin{itemize}
            \item Administrator priviledge needed to add private key to windows ssh-agent service.
            \item Alternatively, you need to have `Git' installed through NMBU software center.
            \begin{itemize}
                \item You need type the passphrase every working session.
            \end{itemize}
        \end{itemize}
    \end{itemize}

    \begin{minted}{bash}
        # Start git and at git prompt:
        eval $(ssh-agent -s)
        ssh-add .ssh/id_ed25519
        ssh -T git@gitlab.com # to check if everything is OK.
        # you can run password-free git command lines here.
        code gitlab-project
        # you can run password-free git command lines in vscode terminal.
    \end{minted}
\end{frame}

\end{document}
